#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>
#include <netinet/in.h>

#include "common/common.h"
#include "common/md5.h"
#include "common/rc4.h"
#include "common/eloop.h"
#include "sha1.h"
#include "wpa.h"
#include "pcl/pcl.h"

#define BIT(n) (1 << (n))
#define PASSPHRASE_LEN 50
#define SSID_LEN 25
#define MAC_LEN 6
#define WPA_NONCE_LEN 32
#define KEY_MIC_LEN 16
#define PMK_LEN 32
#define TMP_BUF_LEN 512
#define DUMP_LEN 256
#define KEY_TYPE BIT(3)
#define HANDSHAKE_LEN 256
#define WPA_KEY_INFO_TYPE_HMAC_MD5_RC4 BIT(0)

struct wpa_ptk {
	u8 mic_key[16]; /* EAPOL-Key MIC Key (MK) */
	u8 encr_key[16]; /* EAPOL-Key Encryption Key (EK) */
	u8 tk1[16]; /* Temporal Key 1 (TK1) */
	union {
		u8 tk2[16]; /* Temporal Key 2 (TK2) */
		struct {
			u8 tx_mic_key[8];
			u8 rx_mic_key[8];
		} auth;
	} u;
};


void wpa_hexdump(const char *, const u8 *, size_t);
void wpa_eapol_key_mic(u8 *, int, u8 *, size_t, u8 *);
void wpa_pmk_to_ptk(u8 *, u8 *, u8 *, u8 *, u8 *, u8 *, size_t);
void create_hmac_buf(u8 *, u8 *, u8 *);
int keyncmp(u8 *, u8 *, int);
int str2hex(u8 *, u8 *, size_t);
